class ExplosionInfoBase expands Info
	abstract;

// replicated built-in vectors hold inexact values, float values are replicated precisely
struct ReplicatedVector
{
	var float X, Y, Z;
};

var ReplicatedVector SourceLocation;
var ReplicatedVector HitLocation, HitNormal;
var UGoldFixSharedInfo SharedInfo;

replication
{
	// Variables the server should send to the client
	reliable if (Role == ROLE_Authority)
		SourceLocation,
		HitLocation,
		HitNormal,
		SharedInfo;
}

// NOTE: LifeSpan == 1
simulated function PostBeginPlay()
{
	SetTimer(0.001, false);
}

simulated function Timer()
{
	if (Level.NetMode != NM_DedicatedServer)
	{
		class'UGoldFixSharedInfo'.static.GetSharedInfo(self, SharedInfo);
		ExplosionHandler();
	}
}

simulated function ExplosionHandler() {} // implemented in derived classes


function AssignSourceLocation(vector pos)
{
	SourceLocation = ConvertToReplicatedVector(pos);
}

function AssignHitLocation(vector pos)
{
	HitLocation = ConvertToReplicatedVector(pos);
}

function AssignHitNormal(vector pos)
{
	HitNormal = ConvertToReplicatedVector(pos);
}

static function ReplicatedVector ConvertToReplicatedVector(vector pos)
{
	local ReplicatedVector result;
	result.X = pos.X;
	result.Y = pos.Y;
	result.Z = pos.Z;
	return result;
}

static function vector ConvertReplicatedVector(ReplicatedVector pos)
{
	local vector result;
	result.X = pos.X;
	result.Y = pos.Y;
	result.Z = pos.Z;
	return result;
}

defaultproperties
{
				RemoteRole=ROLE_SimulatedProxy
				LifeSpan=1.000000
				bAlwaysRelevant=True
}
